"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.reactImportsPlugin = void 0;
const path_1 = __importDefault(require("path"));
// Since React 17, importing React is optional when building with webpack.
// We do need the import with Vite, however.
const reactImportRegExp = /import (\* as )?React[ ,]/;
const extensions = new Set([".js", ".jsx", ".tsx"]);
function reactImportsPlugin() {
    return {
        name: "previewjs:react-imports",
        async transform(code, id) {
            const ext = path_1.default.extname(id);
            if (id.includes("node_modules") ||
                (ext && !extensions.has(ext)) ||
                reactImportRegExp.test(code)) {
                return code;
            }
            return `import React from 'react';${code}`;
        },
    };
}
exports.reactImportsPlugin = reactImportsPlugin;
